; I/O˿ڵַ
io8255_a    equ 230h       ; 8255˿A
io8255_b    equ 231h       ; 8255˿B
io8255_c    equ 232h       ; 8255˿C
io8255_k    equ 233h       ; 8255ƼĴ
io8253_0    equ 210h       ; 8253ʱ0
io8253_1    equ 211h       ; 8253ʱ1
io8253_k    equ 213h       ; 8253ƼĴ
io8259_0    equ 200h       ; 8259жϿ0
io8259_1    equ 201h       ; 8259жϿ1
; ݶζ
data        segment
count1  dw  0          ; жϼ
portcl  db  0ch,14h,21h,22h,0ffh  ; ̵״̬
input   db  ?          
data        ends
; ջζ
st_ssg      segment stack
db  256 dup(?)
st_ssg      ends
; ζ
code    segment
assume  cs:code, ds:data, ss:st_ssg
start:  cli                        ; ж
    mov ax, data               ; ʼݶεַ
    mov ds, ax                 ; ݶμĴ
    ; ʼ8259жϿ
    ; 8259жϿ1
    mov dx, io8259_0
    mov al, 00010011b
    out dx, al
    ; 8259жϿ2
    mov dx, io8259_1
    mov al, 00001000b
    out dx, al
    ; ж
    mov al, 00000001b
    out dx, al
    ; ж
    push ds
    mov ax, 0
    mov ds, ax
    lea ax, cs:int_proc      ; ȡжϴַ
    mov si, 08h              ; ȡMIR0жλ
    add si, si
    add si, si
    mov ds:[si], ax          ; жڵַ
    push cs
    pop ax
    mov ds:[si+2], ax        ; öεַ
    pop ds
    in  al, dx
    and al, 11111110b
    out dx, al
    ; ʼ8253Ƶ
    mov ax, 0
    mov al, 00110110b
    mov dx, io8253_k
    out dx, al
    mov ax, 10000
    mov dx, io8253_0
    out dx, al
    mov al, ah
    out dx, al
    ; ʼ8255˿
    mov dx, io8255_k
    mov al, 10001000b
    out dx, al
    sti                        ; ж

; -------------------- ͨʾ --------------------
light:
    call digital
    ; ƽͨƵ״̬
    mov dx, io8255_b
    handle_traffic_light:
        cmp count1, 500         ; жǷ5sɵͨ
        ja  switch_to_yellow1
        mov al, portcl
        out dx, al
        jmp light_done
    switch_to_yellow1:
        cmp count1, 700         ; жǷ2sɵƵ״̬
        ja  switch_to_green2
        mov al, portcl[1]
        out dx, al
        jmp light_done
    switch_to_green2:
        cmp count1, 1000        ; жǷ3sӸɵͨ
        ja  switch_to_yellow2
        mov al, portcl[2]
        out dx, al
        jmp light_done
    switch_to_yellow2:
        cmp count1, 1200        ; жǷ2sӸɵƵ״̬
        ja  light_cycle_done
        mov al, portcl[3]
        out dx, al
        jmp light_done
    light_cycle_done:
        mov count1, 0           ; һѭ
    light_done:
        call digital
        jmp light
; -------------------- ʱʾ --------------------
digital proc
begin:
    mov dx, io8255_a
    display_time:
        ; ݼֵѡʾ
        cmp count1, 100
        ja  display_4
        mov al, 6Dh
        out dx, al
        jmp exit
    display_4:
        cmp count1, 200
        ja  display_3
        mov al, 66h
        out dx, al
        jmp exit
    display_3:
        cmp count1, 300
        ja  display_2
        mov al, 4Fh
        out dx, al
        jmp exit
    display_2:
        cmp count1, 400
        ja  display_1
        mov al, 5Bh
        out dx, al
        jmp exit
    display_1:
        cmp count1, 500
        ja  display_0
        mov al, 06h
        out dx, al
        jmp exit
    display_0:
        cmp count1, 600
        ja  display_9
        mov al, 5Bh
        out dx, al
        jmp exit
    display_9:
        cmp count1, 700
        ja  display_6
        mov al, 06h
        out dx, al
        jmp exit
    display_6:
        cmp count1, 800
        ja  display_7
        mov al, 4Fh
        out dx, al
        jmp exit
    display_7:
        cmp count1, 900
        ja  display_8
        mov al, 5Bh
        out dx, al
        jmp exit
    display_8:
        cmp count1, 1000
        ja  display_5
        mov al, 06h
        out dx, al
        jmp exit
    display_5:
        cmp count1, 1100
        ja  display_4_end
        mov al, 5Bh
        out dx, al
        jmp exit
    display_4_end:
        cmp count1, 1200
        ja  exit
        mov al, 06h
        out dx, al
    exit:
        ret
digital endp
; -------------------- ʱ --------------------
delay proc near
    push ax
    push cx
    push dx
    mov dl, input
x1:  mov cx, 0ffh
x2:
    loop x2
    dec dl
    jnz x1
    pop dx
    pop cx
    pop ax
    ret
delay endp
; -------------------- жϷ --------------------
int_proc proc far
    push ax
    push dx
    increment_count:
        inc count1
        mov al, 20h
        mov dx, io8259_0
        out dx, al
    pop dx
    pop ax
    sti
    iret
int_proc endp
code ends
end start